
#include 'S3d.au3'
#include <Array.au3>

 ; Startanzahl
Global $iSpheresStart = 45

Opt('GUIOnEventMode', 1)
_GDIPlus_Startup()

Global $bExit = False, $iCnt = 0, $aSpheres[0][3], $iMulti = 1, $iSpheres = 0, $aLoad
Global $bAddSphere = False, $bDelSphere = False, $bRotieren = False, $bLoad = False, $bRechnungStop = False


Global $iW = 500, $iH = 500
Global $hGUI = GUICreate('Kugeloberflche', $iW + 120, $iH)
Global $hBTN_Add = GUICtrlCreateButton('Add', $iW + 10, 20, 100, 25)
GUICtrlSetOnEvent(-1, 'BtnAdd')
Global $hBTN_Del = GUICtrlCreateButton('Del', $iW + 10, 45, 100, 25)
GUICtrlSetOnEvent(-1, 'BtnDel')
Global $hBTN_Rot = GUICtrlCreateButton('Rotieren', $iW + 10, 200, 100, 25)
GUICtrlSetOnEvent(-1, 'BtnRot')
Global $hBTN_Sav = GUICtrlCreateButton('Save', $iW + 10, 350,100, 25)
GUICtrlSetOnEvent(-1, 'BtnSav')
Global $hBTN_Loa = GUICtrlCreateButton('Load', $iW + 10, 375,100, 25)
GUICtrlSetOnEvent(-1, 'BtnLoa')
Global $hBTN_Stp = GUICtrlCreateButton('Stop', $iW + 10, 400,100, 25)
GUICtrlSetOnEvent(-1, 'BtnStp')
GUICtrlCreateEdit('Konv. Multi', $iW + 10, 250, 100, 20, 2049)
Global $hLAB_Mul = GUICtrlCreateEdit('1', $iW + 10, 275, 100, 20, 2049)
Global $hSLI_Mul = GUICtrlCreateSlider($iW + 0, 300, 120, 25)
GUICtrlSetLimit(-1, 120, 1)
GUICtrlSetData($hSLI_Mul, 2)

GUICtrlCreateEdit('Min. Abstand', $iW + 10, 80, 100, 20, 2049)
Global $hLAB_ABS = GUICtrlCreateEdit('', $iW + 10, 105, 100, 20, 2049)
GUICtrlCreateEdit('Anzahl', $iW + 10, 130, 100, 20, 2049)
Global $hLAB_ANZ = GUICtrlCreateEdit('', $iW + 10, 155, 100, 20, 2049)

Global $hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
Global $hBMP = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGFX)
Global $hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
Global $hPEN = _GDIPlus_PenCreate(0xFF20FF40)
Global $hBRU = _GDIPlus_BrushCreateSolid(0x804080FF)
Global $hBRU2 = _GDIPlus_BrushCreateSolid(0x30FF8040)

_S3d_SelectGraphic($hBUF, $iW, $iH)
_S3d_SelectPen($hPEN)
_S3d_SelectBrush($hBRU)
GUISetOnEvent(-3, '_Exit')

For $i = 0 To $iSpheresStart - 1 Step 1
	AddSphere($aSpheres)
Next

_S3d_SetCamera(3 * Cos($iCnt/100), 3 * Sin($iCnt/100), 0, 0, 0, 0)
Update($hLAB_ANZ, $iSpheres)
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit

	If $bAddSphere Then
		$bAddSphere = False
		AddSphere($aSpheres)
		Update($hLAB_ANZ, $iSpheres)
	EndIf

	If $bDelSphere Then
		$bDelSphere = False
		DelSphere($aSpheres)
		Update($hLAB_ANZ, $iSpheres)
	EndIf

	If $bLoad Then
		$bLoad = False
		Load($aSpheres)
		Update($hLAB_ANZ, $iSpheres)
	EndIf

	_S3d_Clear(0xFF111111)
	If $bRotieren Then
		 Add($iCnt, 1)
		_S3d_SetCamera(3 * Cos($iCnt/100), 3 * Sin($iCnt/100), 0, 0, 0, 0)
	EndIf
;~ 	_S3d_SelectBrush($hBRU)


	For $i = 0 To $iSpheres - 1 Step 1
		_S3d_Circle($aSpheres[$i][0], $aSpheres[$i][1], $aSpheres[$i][2], 0.01)
	Next

;~ 	_S3d_SelectBrush($hBRU2)
;~ 	_S3d_Circle(0, 0, 0, 0.45, True)

	If Not $bRechnungStop Then
		$iCalcTimer = TimerInit()
		While TimerDiff($iCalcTimer) < 10 ; 10ms Rechenzeit/Frame
			Calc($aSpheres)
		WEnd
	EndIf

	If GUICtrlRead($hSLI_Mul)^5 <> GUICtrlRead($hLAB_Mul) Then
		GUICtrlSetData($hLAB_Mul, GUICtrlRead($hSLI_Mul)^5)
		$iMulti = Number(GUICtrlRead($hLAB_Mul))
	EndIf

;~ 	ConsoleWrite(TimerDiff($iCalcTimer) & @CRLF)
	_GDIPlus_GraphicsDrawImage($hGFX, $hBMP, 0, 0)
;~ 	Sleep(10)
WEnd

_GDIPlus_BrushDispose($hBRU2)
_GDIPlus_BrushDispose($hBRU)
_GDIPlus_PenDispose($hPen)
_GDIPlus_GraphicsDispose($hBUF)
_GDIPlus_BitmapDispose($hBMP)
_GDIPlus_GraphicsDispose($hGFX)

Func Calc(ByRef $aSpheres)
	Local $u = UBound($aSpheres), $aNew[$u][3], $aVec, $iLen, $aTmp, $iAbstMin = 999
	Local Static $iDTimer = TimerInit()
	For $i = 0 To $u - 1 Step 1
		$aTmp = CalcAbs($aSpheres, $i)
		$aVec = $aTmp[0]
		If $aTmp[1] < $iAbstMin Then $iAbstMin = $aTmp[1]
		$iLen = 0
		For $n = 0 To 2 Step 1
			$aNew[$i][$n] = $aSpheres[$i][$n] + $aVec[$n]/1000
			$iLen += $aNew[$i][$n]^2
		Next
		For $n = 0 To 2 Step 1
			$aNew[$i][$n] /= $iLen^0.5
		Next
;~ 		ConsoleWrite('l' & $i & ': ' & ($aNew[$i][0]^2 + $aNew[$i][1]^2 + $aNew[$i][2]^2)^0.5 & @CRLF)
;~ 		ConsoleWrite('x: ' & $aVec[0] & @CRLF & 'y: ' & $aVec[1] & @CRLF & 'z: ' & $aVec[2] & @CRLF & @CRLF)
	Next

	If TimerDiff($iDTimer) > 1000 Then
		$iDTimer = TimerInit()
		Update($hLAB_ABS, String(Round($iAbstMin, 9)))
	EndIf


	$aSpheres = $aNew
EndFunc

Func CalcAbs(ByRef $aSpheres, $e)
	Local $aVec = [0, 0, 0], $iAbst, $iAbstMin = 999
	For $i = 0 To UBound($aSpheres) - 1 Step 1
		If $i <> $e Then
			$iAbst = (($aSpheres[$e][0] - $aSpheres[$i][0])^2 + ($aSpheres[$e][1] - $aSpheres[$i][1])^2 + ($aSpheres[$e][2] - $aSpheres[$i][2])^2)^0.5
			If $iAbst < $iAbstMin Then $iAbstMin = $iAbst
			$aVec[0] -= ($aSpheres[$i][0] - $aSpheres[$e][0])/$iAbst*$iMulti
			$aVec[1] -= ($aSpheres[$i][1] - $aSpheres[$e][1])/$iAbst*$iMulti
			$aVec[2] -= ($aSpheres[$i][2] - $aSpheres[$e][2])/$iAbst*$iMulti
		EndIf
	Next
	Local $aTmp = [$aVec, $iAbstMin]
	Return $aTmp
EndFunc

Func Update($iCtrl, $sData)
	If GUICtrlRead($iCtrl) <> $sData Then GUICtrlSetData($iCtrl, $sData)
EndFunc

Func DelSphere(ByRef $aSpheres)
	Local $u = UBound($aSpheres)
	If $u > 1 Then
		ReDim $aSpheres[$u - 1][3]
		$iSpheres -= 1
	EndIf
EndFunc

Func BtnAdd()
	$bAddSphere = True
EndFunc

Func BtnDel()
	$bDelSphere = True
EndFunc

Func BtnRot()
	$bRotieren = Not $bRotieren
EndFunc

Func BtnStp()
	$bRechnungStop = Not $bRechnungStop
	GUICtrlSetData($hBTN_Stp, $bRechnungStop ? 'Start' : 'Stop')
EndFunc

Func BtnSav()
	Local $sPfad = FileSaveDialog('Zieldatei eingeben', @ScriptDir, '(*.txt)')
	Local $hFile = FileOpen($sPfad, 1)
	FileWrite($hFile, _
	'##################################################' & @CRLF & _
	'# Koordinaten von Punkten auf einer Kugel mit    #' & @CRLF & _
	'# dem Radius 1. Die Daten liegen als 64-Bit Hex- #' & @CRLF & _
	'# adezimalzahlen im Format X | Y | Z vor.        #' & @CRLF & _
	'##################################################' & @CRLF)
	For $i = 0 To UBound($aSpheres) - 1 Step 1
		FileWrite($hFile, Hex($aSpheres[$i][0], 16) & ' ' & Hex($aSpheres[$i][1], 16) & ' ' & Hex($aSpheres[$i][2], 16) & @CRLF)
	Next
	FileClose($hFile)
EndFunc

Func BtnLoa()
	Local $sPfad = FileOpenDialog('Quelldatei auswhlen', @ScriptDir, '(*.txt)')
	If Not FileExists($sPfad) Then Return
	Local $aRead = StringSplit(FileRead($sPfad), @CRLF, 3), $aTmp
	For $i = UBound($aRead) - 1 To 0 Step -1
		If Not $aRead[$i] Or StringLeft($aRead[$i], 1) = '#' Then _ArrayDelete($aRead, $i)
	Next
	$aLoad = $aRead
	$bLoad = True
EndFunc

Func Load(ByRef $aSpheres)
	$iSpheres = UBound($aLoad)
	ReDim $aSpheres[$iSpheres][3]
	For $i = 0 To $iSpheres - 1 Step 1
		$aTmp = StringSplit($aLoad[$i], ' ', 2)
		$aSpheres[$i][0] = Double($aTmp[0])
		$aSpheres[$i][1] = Double($aTmp[1])
		$aSpheres[$i][2] = Double($aTmp[2])
	Next
EndFunc

Func Double($sHex)
	Local $vHex = DllStructCreate('int64'), $t = DllStructSetData($vHex, 1, '0x' & $sHex), $vDouble = DllStructCreate('double', DllStructGetPtr($vHex)), $nDouble = DllStructGetData($vDouble, 1)
	Return $nDouble
EndFunc

Func AddSphere(ByRef $aSpheres)
	Local $u = UBound($aSpheres)
	ReDim $aSpheres[$u + 1][3]
	Local $r = 1, $pol = Random(0, 180), $azi = Random(0, 360)
	$aSpheres[$u][0] = $r * _Sin($pol) * _Cos($azi)
	$aSpheres[$u][1] = $r * _Sin($pol) * _Sin($azi)
	$aSpheres[$u][2] = $r * _Cos($pol)
	$iSpheres += 1
EndFunc

Func _Sin($n) ; 0 -> 360
	Return Sin($n * $__S3d_PI / 180)
EndFunc

Func _Cos($n) ; 0 -> 360
	Return Cos($n * $__S3d_PI / 180)
EndFunc

Func _Exit()
	$bExit = True
EndFunc

Func Add(ByRef $iVar, $i)
	$iVar += $i
	Return True
EndFunc